# -*- coding: utf-8 -*-
from setuphelpers import *


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    url = "https://pypi.org/project/PyYAML/#files"

    # Getting latest version from official sources
    print("URL used is: %s" % url)
    for bs_search in bs_find_all(url, "a", proxies=proxies):
        if "cp38" in bs_search.text and ".whl" in bs_search.text:
            latest_bin = bs_search.text.strip()
            version = latest_bin.split("-")[1]
            download_url = bs_search["href"]
        else:
            continue
        # Downloading latest binaries
        print("Latest %s version is: %s" % (control.name, version))
        print("Download URL is: %s" % download_url)
        if not isfile(latest_bin):
            print("Downloading: %s" % latest_bin)
            wget(download_url, latest_bin, proxies=proxies)
        else:
            print("Binary is present: %s" % latest_bin)

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Deleting outdated binaries
    remove_outdated_binaries(version, list_extensions="whl")

    # # Install whl in temp folder
    # pip_cmd = '"%s" -m pip download "%s"' % (get_waptpython_path(), latest_bin)
    # if proxies:
    #     pip_cmd += ' --proxy="%s"' % proxies["http"]
    # print(run(pip_cmd))
    if isdir(makepath(os.getcwd(), "WAPT", "persistent")):
        remove_tree(makepath(os.getcwd(), "WAPT", "persistent"))
    mkdirs(makepath(os.getcwd(), "WAPT", "persistent"))
    for whl in glob.glob("*.whl"):
        shutil.move(whl, makepath(os.getcwd(), "WAPT", "persistent"))

    # Validating or not update-package-sources
    return package_updated


def get_persistent_package_file(fname):
    if isfile(makepath(os.getcwd(), "WAPT", "persistent", fname)):
        return makepath(os.getcwd(), "WAPT", "persistent", fname)
    else:
        if control.package_uuid:
            return makepath(WAPT.persistent_root_dir, control.package_uuid, fname)
        else:
            error("unable to get control.package_uuid")


def get_persistent_package_dir():
    if isdir(makepath(os.getcwd(), "WAPT", "persistent")):
        return makepath(os.getcwd(), "WAPT", "persistent")
    else:
        if control.package_uuid:
            return makepath(WAPT.persistent_root_dir, control.package_uuid)
        else:
            error("unable to get control.package_uuid")

def get_waptpython_path():
    if get_os_name() == "Windows":
        return makepath(WAPT.wapt_base_dir, "waptpython.exe")
    else:
        return makepath(WAPT.wapt_base_dir, "waptpython.sh")
